import java.lang.*;
import java.util.*;

class Packet
{
  private short buffer[];
  private static Random rnd = new Random();

  static
    {
    }

  Packet()
    {
      buffer = null;
    }

  Packet( int sz )
    {
      int count;

      //  sz is in bytes
      buffer = new short[ ( sz + ( sz % 2 ) ) / 2 ];

      for ( count = 0; count  <  buffer.length; count ++ )
        buffer[ count ] = (short) rnd.nextInt();
    }

  public int checksum()
  {
    int o = 0;
    int sum = 0;
    int len = buffer.length;
   
    while ( o  < len )
      {
        sum += buffer[ o++ ];
        if ( sum  >  0x0ffff )
          sum = ( sum & 0x0ffff ) + 1;
      }

    return( ~sum );
  }
}

class Checksum
{
	public static void main (String args[]) {
                int sz;
                int count;
                Packet pkt;
                Timer t = new Timer();

                for ( sz = 100; sz  <=  4100; sz += 100 )
                  {
                    t.reset();
                    for ( count = 0; count < 5000; count ++ )
                      {
                        pkt = new Packet( sz );
                        t.start();
                        pkt.checksum();
                        t.stop();
                      }
                    System.out.println( "Count " + count + "\t  Size " + sz + "\t  MS " + t.ms() + "\t  Sys " + t.sys() + "\t User " + t.user() );
                    System.out.println( "Avg   \t\t  Size " + sz + "\t  MS " + t.ms()/count + "\t  Sys " + t.sys()/count + "\t User " + t.user()/count );
                    System.out.println( "" );
                  }
	}
}

