import java.lang.*;

class Timer
{
   private long ms = 0;
   private long sys = 0;
   private long user = 0;

   private long ms_start = 0;
   private long sys_start = 0;
   private long user_start = 0;

   private long ms_stop = 0;
   private long sys_stop = 0;
   private long user_stop = 0;

   private boolean running = false;

   static
     {
       System.load( "timer.so" );
     }

   Timer()
     {
       ms = 0;
       sys = 0;
       user = 0;
       running = false;
     }

   Timer( long init_ms, long init_sys, long init_user )
     {
       ms = init_ms;
       sys = init_sys;
       user = init_user;
       running = false;
     }

   private native void currentSystemTimes( boolean running );

   public synchronized void start()
     {
       if ( ! running )
         {
	   ms_start = System.currentTimeMillis();
	   currentSystemTimes( running );
	   running = true;
	 }
     }

   public synchronized void stop()
     {
       if ( running )
         {
	   ms_stop = System.currentTimeMillis();
	   currentSystemTimes( running );
	   running = false;
	 }

       ms += ( ms_stop - ms_start );
       sys += ( sys_stop - sys_start );
       user += ( user_stop - user_start );
     }

   public void reset()
     {
       ms = 0;
       sys = 0;
       user = 0;
     }

   public long ms()            { return ms; }
   public long sys()           { return sys; }
   public long user()          { return user; }
   public boolean isRunning()  { return running; }
}
